/*
   _____                       _____          _            
  / ____|                     |  __ \        | |           
 | (___  _   _ _ __   ___ _ __| |__) |___  __| |_   ___  __
  \___ \| | | | '_ \ / _ \ '__|  _  // _ \/ _` | | | \ \/ /
  ____) | |_| | |_) |  __/ |  | | \ \  __/ (_| | |_| |>  < 
 |_____/ \__,_| .__/ \___|_|  |_|  \_\___|\__,_|\__,_/_/\_\
              | |                                          
              |_|                               By Jana Sol
*/

//Credits:
//Jana Sol: Mod creator, SuperRework/SuperRedux creator
//BlueParasolKirby: Sol Form support and super cancelling
//Lunar: Allsuper.wad creator, the inspiration of this

//all characters can go super, with any music you want
//adding music is simple, just follow this template

//Hi, sol music doesnt currently work due to jankery with Sol forms forcing music changes

/*
PtOSuperRedux.AddSuperMusic({track = lump name as a string, name = the name you want the music to be called})
PtOSuperRedux.AddSolMusic({track = lump name as a string, name = the name you want the music to be called})
*/

if not PtOSuperRedux
	rawset(_G,"PtOSuperRedux",{})
end

PtOSuperRedux.supermusic = $ or {}
PtOSuperRedux.solmusic = $ or {}

PtOSuperRedux.AddSuperMusic = function(...) -- expects (track, name)
	local packedargs = {...}
	for k, v in ipairs(packedargs) do
		table.insert(PtOSuperRedux.supermusic, v)
		print("PtOSR: Added "..v.name.." super music")
	end
end

PtOSuperRedux.AddSuperMusic(
	{
		track = "_SUPER",
		name = "vanilla"
	},
	{
		track = "SMSUPR",
		name = "sonicmania"
	},
	{
		track = "S3SUPR",
		name = "sonic3"
	},
	{
		track = "S2SUPER",
		name = "sonic2"
	},
	{
		track = "AVSUPR",
		name = "liveandlearn"
	}
)

PtOSuperRedux.AddSolMusic = function(...) -- expects (track, name)
	local packedargs = {...}
	for k, v in ipairs(packedargs) do
		table.insert(PtOSuperRedux.solmusic, v)
		print("PtOSR: Added "..v.name.." super music from")
	end
end

PtOSuperRedux.AddSolMusic(
	{
		track = "METAM",
		name = "default"
	}
)

local function supertoggle(p, arg) -- but why would you ever want to turn it off :(
	arg = tostring(arg):lower()
	if(arg == "on" or arg == "off") then
		if(arg == "on") then 
			p.supertoggle = 1
		elseif(arg == "off") then 
			p.supertoggle = 0
		end 
		CONS_Printf(p, "\131* Super forms have been toggled \130" .. arg:upper() .. "\131.")
		S_StartSound(nil, sfx_radio, p)
	else
		CONS_Printf(p, "\135* Please choose between \130ON \135or \130OFF\135.")
		S_StartSound(nil, sfx_radio, p)
	end
end

local function supermusic(p, arg) 
	arg = tostring(arg):lower()
	local musicselected = false
	if arg == "off"
		p.supermusic = 0
	end
	for k, v in ipairs(PtOSuperRedux.supermusic) do
		if arg == PtOSuperRedux.supermusic[k].name
			p.supermusic = PtOSuperRedux.supermusic[k].track
			CONS_Printf(p, "\131* Super music has been changed to \130" .. PtOSuperRedux.supermusic[k].name:upper() .. "\131.")
			S_StartSound(nil, sfx_radio, p)
			musicselected = true
			return
		end
	end
	if musicselected == false
		local listOfMusics = ""
		for k, v in ipairs(PtOSuperRedux.supermusic) do
			listOfMusics = $..PtOSuperRedux.supermusic[k].name.."\n"
		end
		CONS_Printf(p, "\135* Selectable Super Themes are:\n\130"..listOfMusics:upper())
		
	end
end

local function solmusic(p, arg)
	arg = tostring(arg):lower()
	local musicselected = false
	if arg == "off"
		p.solmusic = 0
	end
	for k, v in ipairs(PtOSuperRedux.solmusic) do
		if arg == PtOSuperRedux.solmusic[k].name
			p.solmusic = PtOSuperRedux.solmusic[k].track
			CONS_Printf(p, "\131* Sol music has been changed to \130" .. PtOSuperRedux.solmusic[k].name:upper() .. "\131.")
			S_StartSound(nil, sfx_radio, p)
			musicselected = true
			return
		end
	end
	if musicselected == false
		local listOfMusics = ""
		for k, v in ipairs(PtOSuperRedux.solmusic) do
			listOfMusics = $..PtOSuperRedux.solmusic[k].name.."\n"
		end
		CONS_Printf(p, "Selectable Sol Themes are:\n"..listOfMusics:upper())
		
	end
end

local function superbutton(p, arg) -- but why would you ever want to not use tossflag :(
	arg = tostring(arg):lower()
	if(arg == "tossflag" or arg == "spin" or arg == "custom1" or arg == "custom2" or arg == "custom3") then
		if(arg == "tossflag") then 
			p.superbutton = BT_TOSSFLAG
		elseif(arg == "spin") then 
			p.superbutton = BT_SPIN
		elseif(arg == "custom1") then 
			p.superbutton = BT_CUSTOM1
		elseif(arg == "custom2") then 
			p.superbutton = BT_CUSTOM2
		elseif(arg == "custom3") then 
			p.superbutton = BT_CUSTOM3
		end 
		CONS_Printf(p, "\131* Super button has been changed to \130" .. arg:upper() .. "\131.")
		S_StartSound(nil, sfx_radio, p)
	else
		CONS_Printf(p, "\135* Please choose between \130TOSSFLAG\135, \130SPIN\135, \130CUSTOM1\135, \130CUSTOM2 \135or, \130CUSTOM3\135.")
		S_StartSound(nil, sfx_radio, p)
	end
end

COM_AddCommand("supertoggle", supertoggle, 0)

COM_AddCommand("supermusic", supermusic, 0)

--COM_AddCommand("solmusic", solmusic, 0)

COM_AddCommand("superbutton", superbutton, 0)

addHook("ThinkFrame", function()
    for player in players.iterate do
		--print(S_MusicName())
		if player.solchar then player.solchar.spindown = true end
		player.currentmusic = S_MusicName()
		if player.superbutton == nil then 
			player.superbutton = BT_TOSSFLAG 
		end
		if player.supermusic == nil then 
			player.supermusic = "_SUPER"
		end
		if player.solmusic == nil then 
			player.solmusic = "METAM"
		end
		if (player.charflags & SF_SUPER) and player.powers[pw_super] == 0
			player.charflags = $ & ~SF_SUPER
			player.powers[pw_super] = 0
			COM_BufInsertText(player, "tunes -default")
		elseif player.solchar 
			if not player.solchar.istransformed
				COM_BufInsertText(player, "tunes -default")
			end
		end
		if player.nosuper == nil then
			player.nosuper = false
		end
		if player.solchar
				player.nosuper = true
		else
			player.nosuper = false
		end
		if player.transtimer == nil then
			player.transtimer = 0
		elseif player.transtimer > 0
			player.transtimer = $ - 1
		else
			player.transtimer = 0
		end
		if player.mo.skin == "supersonic" and player.powers[pw_super] == 0 //Super Sonic (character) completely breaks without this.
			player.charflags = $ | SF_SUPER
			player.powers[pw_super] = 1
		end
		if player.supertoggle ~= 0 
			if player.solchar and player.cmd.buttons & player.superbutton and player.solchar.hasallemeralds and not P_IsObjectOnGround(player.mo) and player.transtimer == 0
				if player.rings >= 50 and player.powers[pw_super] == 0 and not (player.solchar and player.solchar.istransformed > 0)
					player.solchar.istransformed = 1
					player.solchar.spindown = true
					player.mo.state = S_PLAY_SUPER_TRANS1
					S_StartSound(player.mo, sfx_secir)
					player.powers[pw_extralife] = 0
					player.powers[pw_sneakers] = 0
					player.powers[pw_invulnerability] = 0
					player.solchar.emeraldcircle = 1
					if player.solmusic ~= 0 then COM_BufInsertText(player, "tunes "..player.solmusic) end
				elseif (player.solchar and player.solchar.istransformed > 0)
					player.solchar.earlyburncancel = true
				else
					player.powers[pw_super] = 0
					player.mo.color = player.skincolor
					player.powers[pw_invulnerability] = 1
					COM_BufInsertText(player, "tunes -default")
				end
				player.transtimer = 70
			elseif player.cmd.buttons & player.superbutton and emeralds == 127 and not P_IsObjectOnGround(player.mo) and player.transtimer == 0 and player.nosuper == false
				if player.rings >= 50 and player.powers[pw_super] == 0
					player.charflags = $ | SF_SUPER
					player.powers[pw_super] = 1
					player.mo.state = S_PLAY_SUPER_TRANS1
					S_StartSound(player.mo, sfx_supert, player)
					if player.supermusic ~= 0 then COM_BufInsertText(player, "tunes "..player.supermusic) end
				else
					player.powers[pw_super] = 0
					player.mo.color = player.skincolor
					player.powers[pw_invulnerability] = 1
					COM_BufInsertText(player, "tunes -default")
				end
				player.transtimer = 70
			end
		end
	end
end)
